"""Constants for use during NTDS parsing"""

from __future__ import annotations

from ldap3.protocol.formatters.formatters import format_ad_timestamp

SAM_NORMAL_USER_ACCOUNT = 0x30000000
SAM_MACHINE_ACCOUNT = 0x30000001
SAM_TRUST_ACCOUNT = 0x30000002
ACCOUNT_TYPES = (SAM_NORMAL_USER_ACCOUNT, SAM_MACHINE_ACCOUNT, SAM_TRUST_ACCOUNT)

# oMSyntax -> type infix
# See: https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-adts/7cda533e-d7a4-4aec-a517-91d02ff4a1aa
ESENT_LDAP_TYPES = {
    1: {
        "LDAP syntax name": "Boolean",
        "cast": bool,
        "type": None,
    },
    10: {
        "LDAP syntax name": "Enumeration",
        "cast": None,
        "type": None,
    },
    # b"ATTj589832": "userAccountControl"
    2: {
        "LDAP syntax name": "Integer",
        "cast": int,
        "type": "j",
    },
    #  ! Multiple structures - can be int, format_ad_timestamp, or even interval
    # b"ATTq589920": "pwdLastSet"
    65: {
        "LDAP syntax name": "Large Integer",
        "cast": None,
        "type": "q",
    },
    # skipping Object classes (think 'manager')...
    27: {
        "LDAP syntax name": "String(Case)",
        "cast": None,
    },
    22: {
        "LDAP syntax name": "String(IA5)",
        "cast": None,
    },
    # b"ATTp131353": "nTSecurityDescriptor"
    66: {
        "LDAP syntax name": "String(NT-Sec-Desc)",
        "cast": None,
        "type": "p",
    },
    18: {
        "LDAP syntax name": "String(Numeric)",
        "cast": None,
    },
    6: {
        "LDAP syntax name": "String(Object-Identifier)",
        "cast": None,
    },
    # TODO: Sort this out
    # b"ATTk589879": "dBCSPwd"
    # b"ATTr589970": "objectSid"
    4: {
        "LDAP syntax name": "String(Octet) | String(Sid)",
        "cast": None,
        "type": "k | r",
    },
    19: {
        "LDAP syntax name": "String(Printable)",
        "cast": None,
    },
    20: {
        "LDAP syntax name": "String(Teletex)",
        "cast": None,
    },
    # b"ATTm590045": "sAMAccountName"
    64: {
        "LDAP syntax name": "String(Unicode)",
        "cast": str,
        "type": "m",
    },
    # NOTE: Only 4 uncommon attributes, so not a concern
    # b"ATTl590704": "fRSTimeLastCommand"
    23: {
        "LDAP syntax name": "String(UTC-Time)",
        "cast": format_ad_timestamp,
        "type": "l",
    },
    # b"ATTl131074": "whenCreated"
    24: {
        "LDAP syntax name": "String(Generalized-Time)",
        "cast": format_ad_timestamp,
        "type": "l",
    },
}

# Types by char + potential usage:
# ATTb (type: signed 32-bit int -> object)
# ATTj (type: signed 32-bit int)
# ATTl and ATTq (type: currency) look related to datetime
# ATTm (type: large text)
# ATTp (type: large binary data)
# ATTr (type: large binary data)
ESENT_TO_LDAP = {
    b"ATTb131079": "subRefs",
    b"ATTb131088": "nCName",
    b"ATTb131108": "dMDLocation",
    b"ATTb1376270": "documentAuthor",
    b"ATTb1376277": "secretary",
    b"ATTb1376294": "associatedName",
    b"ATTb33": "roleOccupant",
    b"ATTb34": "seeAlso",
    b"ATTb49": "distinguishedName",
    b"ATTb50": "uniqueMember",
    b"ATTb589856": "domainPolicyObject",
    b"ATTb589864": "fromServer",
    b"ATTb589881": "defaultLocalPolicyObject",
    b"ATTb589921": "preferredOU",
    b"ATTb590037": "defaultClassStore",
    b"ATTb590038": "nextLevelStore",
    b"ATTb590127": "notificationList",
    b"ATTb590192": "rIDManagerReference",
    b"ATTb590193": "fSMORoleOwner",
    b"ATTb590246": "domainPolicyReference",
    b"ATTb590281": "localPolicyReference",
    b"ATTb590295": "trustParent",
    b"ATTb590296": "domainCrossRef",
    b"ATTb590304": "defaultGroup",
    b"ATTb590318": "siteServer",
    b"ATTb590338": "physicalLocationObject",
    b"ATTb590341": "ipsecPolicyReference",
    b"ATTb590361": "dynamicLDAPServer",
    b"ATTb590381": "parentCA",
    b"ATTb590448": "ipsecOwnersReference",
    b"ATTb590450": "ipsecISAKMPReference",
    b"ATTb590451": "ipsecNFAReference",
    b"ATTb590452": "ipsecNegotiationPolicyReference",
    b"ATTb590453": "ipsecFilterReference",
    b"ATTb590468": "showInAddressBook",
    b"ATTb590476": "assistant",
    b"ATTb590488": "syncWithObject",
    b"ATTb590492": "domainCAs",
    b"ATTb590493": "rIDSetReferences",
    b"ATTb590498": "rootTrust",
    b"ATTb590508": "certificateAuthorityObject",
    b"ATTb590510": "domainID",
    b"ATTb590513": "cRLObject",
    b"ATTb590518": "previousParentCA",
    b"ATTb590519": "pendingParentCA",
    b"ATTb590520": "currentParentCA",
    b"ATTb590605": "lastKnownParent",
    b"ATTb590606": "objectCategory",
    b"ATTb590607": "defaultObjectCategory",
    b"ATTb590615": "transportType",
    b"ATTb590680": "netbootNewMachineOU",
    b"ATTb590752": "mSMQOutRoutingServers",
    b"ATTb590753": "mSMQInRoutingServers",
    b"ATTb590767": "mSMQSite1",
    b"ATTb590768": "mSMQSite2",
    b"ATTb590769": "mSMQSiteGates",
    b"ATTb591049": "mSMQPrevSiteGates",
    b"ATTb591066": "dNReferenceUpdate",
    b"ATTb591068": "addressBookRoots",
    b"ATTb591069": "globalAddressList",
    b"ATTb591070": "interSiteTopologyGenerator",
    b"ATTb591134": "mSMQSiteGatesMig",
    b"ATTb591170": "templateRoots",
    b"ATTb591251": "msCOM-DefaultPartitionLink",
    b"ATTb591268": "msDS-Preferred-GC-Site",
    b"ATTb591923": "msDS-ClaimAttributeSource",
    b"ATTb592001": "msKds-DomainID",
    b"ATTb592085": "msDS-DeviceLocation",
    b"ATTc0": "objectClass",
    b"ATTc131080": "possSuperiors",
    b"ATTc131093": "subClassOf",
    b"ATTc131094": "governsID",
    b"ATTc131096": "mustContain",
    b"ATTc131097": "mayContain",
    b"ATTc131098": "rDNAttID",
    b"ATTc131102": "ATTributeID",
    b"ATTc131104": "ATTributeSyntax",
    b"ATTc131423": "auxiliaryClass",
    b"ATTc590019": "systemPossSuperiors",
    b"ATTc590020": "systemMayContain",
    b"ATTc590021": "systemMustContain",
    b"ATTc590022": "systemAuxiliaryClass",
    b"ATTc590719": "transportAddressAttribute",
    b"ATTe131422": "addressType",
    b"ATTe131531": "networkAddress",
    b"ATTe2": "knowledgeInformation",
    b"ATTe590479": "legacyExchangeDN",
    b"ATTe590746": "mSMQLabel",
    b"ATTe590757": "mSMQComputerType",
    b"ATTe590764": "mSMQCSPName",
    b"ATTe590789": "mSMQSiteName",
    b"ATTf131425": "displayNamePrintable",
    b"ATTf1376293": "associatedDomain",
    b"ATTf1966082": "unstructuredName",
    b"ATTf2162997": "msSFU30Name",
    b"ATTf2163011": "msSFU30Aliases",
    b"ATTf2163012": "msSFU30KeyValues",
    b"ATTf2163027": "msSFU30NisDomain",
    b"ATTf2163028": "msSFU30Domains",
    b"ATTf2163029": "msSFU30YpServers",
    b"ATTf2163033": "msSFU30NSMAPFieldPosition",
    b"ATTf2163036": "msSFU30NetgroupHostAtDomain",
    b"ATTf2163037": "msSFU30NetgroupUserAtDomain",
    b"ATTf2163040": "msSFU30CryptMethod",
    b"ATTf2424834": "gecos",
    b"ATTf2424835": "unixHomeDirectory",
    b"ATTf2424836": "loginShell",
    b"ATTf2424844": "memberUid",
    b"ATTf2424845": "memberNisNetgroup",
    b"ATTf2424846": "nisNetgroupTriple",
    b"ATTf2424848": "ipServiceProtocol",
    b"ATTf2424851": "ipHostNumber",
    b"ATTf2424852": "ipNetworkNumber",
    b"ATTf2424853": "ipNetmaskNumber",
    b"ATTf2424854": "macAddress",
    b"ATTf2424855": "bootParameter",
    b"ATTf2424856": "bootFile",
    b"ATTf2424858": "nisMapName",
    b"ATTf2424859": "nisMapEntry",
    b"ATTf27": "destinationIndicator",
    b"ATTf5": "serialNumber",
    b"ATTf590528": "dhcpServers",
    b"ATTf590529": "dhcpSubnets",
    b"ATTf590530": "dhcpMask",
    b"ATTf590531": "dhcpRanges",
    b"ATTf590532": "dhcpSites",
    b"ATTf590533": "dhcpReservations",
    b"ATTf590534": "superScopes",
    b"ATTf590537": "optionsLocation",
    b"ATTf590540": "mscopeId",
    b"ATTf590541": "dhcpState",
    b"ATTf590947": "msNPCalledStationID",
    b"ATTf590948": "msNPCallingStationID",
    b"ATTf590954": "msNPSavedCallingStationID",
    b"ATTf590969": "msRADIUSCallbackNumber",
    b"ATTf590982": "msRADIUSFramedRoute",
    b"ATTf591013": "msRASSavedCallbackNumber",
    b"ATTf591015": "msRASSavedFramedRoute",
    b"ATTf591737": "msRADIUS-FramedInterfaceId",
    b"ATTf591738": "msRADIUS-SavedFramedInterfaceId",
    b"ATTf591739": "msRADIUS-FramedIpv6Prefix",
    b"ATTf591740": "msRADIUS-SavedFramedIpv6Prefix",
    b"ATTf591741": "msRADIUS-FramedIpv6Route",
    b"ATTf591742": "msRADIUS-SavedFramedIpv6Route",
    b"ATTg24": "x121Address",
    b"ATTg25": "internationalISDNNumber",
    b"ATTh590442": "wellKnownObjects",
    b"ATTh591073": "proxiedObjectName",
    b"ATTh591183": "otherWellKnownObjects",
    b"ATTh591232": "mS-DS-ReplicatesNCReason",
    b"ATTi131105": "isSingleValued",
    b"ATTi131120": "isDeleted",
    b"ATTi131241": "showInAdvancedViewOnly",
    b"ATTi131452": "extendedCharsAllowed",
    b"ATTi131595": "proxyGenerationEnabled",
    b"ATTi131629": "Enabled",
    b"ATTi2293769": "msDFSR-Enabled",
    b"ATTi2293779": "msDFSR-RdcEnabled",
    b"ATTi2293788": "msDFSR-ReadOnly",
    b"ATTi2293792": "msDFSR-DisablePacketPrivacy",
    b"ATTi589848": "contentIndexingAllowed",
    b"ATTi589860": "enabledConnection",
    b"ATTi589865": "generatedConnection",
    b"ATTi589994": "systemOnly",
    b"ATTi590066": "printCollate",
    b"ATTi590067": "printColor",
    b"ATTi590099": "printKeepPrintedJobs",
    b"ATTi590105": "printStaplingSupported",
    b"ATTi590202": "dnsAllowDynamic",
    b"ATTi590203": "dnsAllowXFR",
    b"ATTi590342": "defaultHidingValue",
    b"ATTi590463": "isMemberOfPartialAttributeSet",
    b"ATTi590485": "isDefunct",
    b"ATTi590592": "aCSEnableRSVPMessageLogging",
    b"ATTi590594": "aCSEnableACSService",
    b"ATTi590630": "treatAsLeaf",
    b"ATTi590673": "netbootAllowNewClients",
    b"ATTi590674": "netbootLimitClients",
    b"ATTi590677": "netbootAnswerRequests",
    b"ATTi590678": "netbootAnswerOnlyValidClients",
    b"ATTi590692": "isCriticalSystemObject",
    b"ATTi590723": "aCSEnableRSVPAccounting",
    b"ATTi590742": "mSMQJournal",
    b"ATTi590747": "mSMQAuthenticate",
    b"ATTi590750": "mSMQTransactional",
    b"ATTi590758": "mSMQForeign",
    b"ATTi590763": "mSMQNameStyle",
    b"ATTi590776": "mSMQMigrated",
    b"ATTi590785": "mSMQSiteForeign",
    b"ATTi590943": "msNPAllowDialin",
    b"ATTi591036": "isEphemeral",
    b"ATTi591050": "mSMQDependentClientServices",
    b"ATTi591051": "mSMQRoutingServices",
    b"ATTi591052": "mSMQDsServices",
    b"ATTi591061": "mSMQRoutingService",
    b"ATTi591062": "mSMQDsService",
    b"ATTi591063": "mSMQDependentClientService",
    b"ATTi591135": "printDuplexSupported",
    b"ATTi591197": "mS-SQL-Clustered",
    b"ATTi591216": "mS-SQL-InformationDirectory",
    b"ATTi591218": "mS-SQL-AllowAnonymousSubscription",
    b"ATTi591227": "mS-SQL-AllowKnownPullSubscription",
    b"ATTi591228": "mS-SQL-AllowImmediateUpdatingSubscription",
    b"ATTi591229": "mS-SQL-AllowQueuedUpdatingSubscription",
    b"ATTi591230": "mS-SQL-AllowSnapshotFilesFTPDownloading",
    b"ATTi591231": "mS-SQL-ThirdParty",
    b"ATTi591238": "dNSTombstoned",
    b"ATTi591537": "MSMQ-SecuredSource",
    b"ATTi591604": "hideFromAB",
    b"ATTi591629": "msDS-AzGenerateAudits",
    b"ATTi591642": "msDS-AzTaskIsRoleDefinition",
    b"ATTi591803": "msTSAllowLogon",
    b"ATTi591808": "msTSReconnectionAction",
    b"ATTi591809": "msTSBrokenConnectionAction",
    b"ATTi591810": "msTSConnectClientDrives",
    b"ATTi591811": "msTSConnectPrinterDrives",
    b"ATTi591812": "msTSDefaultToMainPrinter",
    b"ATTi591839": "msDS-PasswordComplexityEnabled",
    b"ATTi591840": "msDS-PasswordReversibleEncryptionEnabled",
    b"ATTi591882": "isRecycled",
    b"ATTi591919": "msDS-IsUsedAsResourceSecurityAttribute",
    b"ATTi591954": "msDNS-IsSigned",
    b"ATTi591955": "msDNS-SignWithNSEC3",
    b"ATTi591956": "msDNS-NSEC3OptOut",
    b"ATTi591959": "msDNS-RFC5011KeyRollovers",
    b"ATTi591970": "msDNS-ParentHasSecureDelegation",
    b"ATTi591983": "msDS-ClaimIsValueSpaceRestricted",
    b"ATTi591984": "msDS-ClaimIsSingleValued",
    b"ATTi592010": "msDS-IsPossibleValuesPresent",
    b"ATTi592037": "msDS-RIDPoolAllocationEnabled",
    b"ATTi592072": "msDS-IsEnabled",
    b"ATTi592094": "msDS-IsManaged",
    b"ATTi592095": "msDS-CloudIsManaged",
    b"ATTi592099": "msDS-CloudIsEnabled",
    b"ATTi592121": "msDS-AuthNPolicyEnforced",
    b"ATTi592122": "msDS-AuthNPolicySiloEnforced",
    b"ATTi592138": "msDS-IsCompliant",
    b"ATTi592168": "msDS-ExpirePasswordsOnSmartCardOnlyAccounts",
    b"ATTi592172": "msDS-UserAllowedNTLMNetworkAuthentication",
    b"ATTi592173": "msDS-ServiceAllowedNTLMNetworkAuthentication",
    b"ATTj131073": "instanceType",
    b"ATTj131106": "rangeLower",
    b"ATTj131107": "rangeUpper",
    b"ATTj131121": "mAPIID",
    b"ATTj131122": "linkID",
    b"ATTj131126": "tombstoneLifetime",
    b"ATTj131148": "objectVersion",
    b"ATTj131207": "cost",
    b"ATTj131303": "oMSyntax",
    b"ATTj131373": "garbageCollPeriod",
    b"ATTj131406": "searchFlags",
    b"ATTj131442": "objectClassCategory",
    b"ATTj131541": "USNIntersite",
    b"ATTj131543": "schemaVersion",
    b"ATTj2163030": "msSFU30MaxGidNumber",
    b"ATTj2163031": "msSFU30MaxUidNumber",
    b"ATTj2163038": "msSFU30IsValidContainer",
    b"ATTj2293770": "msDFSR-ReplicationGroupType",
    b"ATTj2293771": "msDFSR-TombstoneExpiryInMin",
    b"ATTj2293776": "msDFSR-Flags",
    b"ATTj2293777": "msDFSR-Options",
    b"ATTj2293782": "msDFSR-RootFence",
    b"ATTj2293785": "msDFSR-Priority",
    b"ATTj2293789": "msDFSR-CachePolicy",
    b"ATTj2293790": "msDFSR-MinDurationCacheInMin",
    b"ATTj2293791": "msDFSR-MaxAgeInCacheInMin",
    b"ATTj2293797": "msDFSR-Options2",
    b"ATTj2293800": "msDFSR-StagingCleanupTriggerInPercent",
    b"ATTj2424832": "uidNumber",
    b"ATTj2424833": "gidNumber",
    b"ATTj2424837": "shadowLastChange",
    b"ATTj2424838": "shadowMin",
    b"ATTj2424839": "shadowMax",
    b"ATTj2424840": "shadowWarning",
    b"ATTj2424841": "shadowInactive",
    b"ATTj2424842": "shadowExpire",
    b"ATTj2424843": "shadowFlag",
    b"ATTj2424847": "ipServicePort",
    b"ATTj2424849": "ipProtocolNumber",
    b"ATTj2424850": "oncRpcNumber",
    b"ATTj28": "preferredDeliveryMethod",
    b"ATTj589832": "userAccountControl",
    b"ATTj589835": "authenticationOptions",
    b"ATTj589836": "badPwdCount",
    b"ATTj589840": "codePage",
    b"ATTj589849": "countryCode",
    b"ATTj589855": "fRSReplicaSetType",
    b"ATTj589862": "flags",
    b"ATTj589880": "localPolicyFlags",
    b"ATTj589882": "localeID",
    b"ATTj589892": "machineArchitecture",
    b"ATTj589895": "machineRole",
    b"ATTj589897": "lockoutThreshold",
    b"ATTj589903": "minPwdLength",
    b"ATTj589912": "nextRid",
    b"ATTj589917": "pwdProperties",
    b"ATTj589919": "pwdHistoryLength",
    b"ATTj589922": "primaryGroupID",
    b"ATTj589932": "remoteSourceType",
    b"ATTj589941": "rpcNsPriority",
    b"ATTj589944": "schemaFlagsEx",
    b"ATTj589956": "trustDirection",
    b"ATTj589958": "trustPosixOffset",
    b"ATTj589960": "trustType",
    b"ATTj589965": "versionNumber",
    b"ATTj589968": "operatorCount",
    b"ATTj589969": "revision",
    b"ATTj589974": "adminCount",
    b"ATTj589976": "groupAttributes",
    b"ATTj589977": "rid",
    b"ATTj589978": "serverState",
    b"ATTj589979": "uASCompat",
    b"ATTj589981": "serverRole",
    b"ATTj589993": "logonCount",
    b"ATTj590055": "priority",
    b"ATTj590056": "defaultPriority",
    b"ATTj590057": "printStartTime",
    b"ATTj590058": "printEndTime",
    b"ATTj590062": "printMaxResolutionSupported",
    b"ATTj590065": "printMaxCopies",
    b"ATTj590071": "printAttributes",
    b"ATTj590100": "driverVersion",
    b"ATTj590101": "printMaxXExtent",
    b"ATTj590102": "printMaxYExtent",
    b"ATTj590103": "printMinXExtent",
    b"ATTj590104": "printMinYExtent",
    b"ATTj590106": "printMemory",
    b"ATTj590108": "bytesPerMinute",
    b"ATTj590109": "printRate",
    b"ATTj590114": "printNumberUp",
    b"ATTj590126": "sAMAccountType",
    b"ATTj590131": "options",
    b"ATTj590148": "packageType",
    b"ATTj590151": "packageFlags",
    b"ATTj590152": "versionNumberHi",
    b"ATTj590153": "versionNumberLo",
    b"ATTj590181": "nTMixedDomain",
    b"ATTj590198": "rIDNextRID",
    b"ATTj590199": "systemFlags",
    b"ATTj590204": "dnsSecureSecondaries",
    b"ATTj590205": "dnsNotifySecondaries",
    b"ATTj590282": "qualityOfService",
    b"ATTj590294": "trustAttributes",
    b"ATTj590309": "fRSUpdateTimeout",
    b"ATTj590314": "fRSDSPoll",
    b"ATTj590328": "seqNotification",
    b"ATTj590330": "objectCount",
    b"ATTj590331": "volumeCount",
    b"ATTj590358": "fRSLevelLimit",
    b"ATTj590400": "meetingMaxParticipants",
    b"ATTj590413": "meetingBandwidth",
    b"ATTj590446": "ipsecDataType",
    b"ATTj590455": "printPagesPerMinute",
    b"ATTj590457": "policyReplicationFlags",
    b"ATTj590460": "privilegeAttributes",
    b"ATTj590490": "syncAttributes",
    b"ATTj590501": "replTopologyStayOfExecution",
    b"ATTj590523": "dhcpType",
    b"ATTj590574": "groupType",
    b"ATTj590577": "nameServiceFlags",
    b"ATTj590578": "rpcNsEntryFlags",
    b"ATTj590579": "domainIdentifier",
    b"ATTj590581": "aCSDirection",
    b"ATTj590585": "aCSMaxDurationPerFlow",
    b"ATTj590586": "aCSServiceType",
    b"ATTj590587": "aCSTotalNoOfFlows",
    b"ATTj590588": "aCSPriority",
    b"ATTj590593": "aCSEventLogLevel",
    b"ATTj590598": "aCSMaxNoOfLogFiles",
    b"ATTj590599": "aCSMaxSizeOfRSVPLogFile",
    b"ATTj590600": "aCSDSBMPriority",
    b"ATTj590601": "aCSDSBMRefresh",
    b"ATTj590602": "aCSDSBMDeadTime",
    b"ATTj590603": "aCSCacheTimeout",
    b"ATTj590670": "msiScriptSize",
    b"ATTj590671": "installUiLevel",
    b"ATTj590672": "appSchemaVersion",
    b"ATTj590675": "netbootMaxClients",
    b"ATTj590676": "netbootCurrentClientCount",
    b"ATTj590698": "fRSFlags",
    b"ATTj590701": "fRSPartnerAuthLevel",
    b"ATTj590716": "gPOptions",
    b"ATTj590717": "gPCFunctionalityVersion",
    b"ATTj590725": "aCSMaxNoOfAccountFiles",
    b"ATTj590726": "aCSMaxSizeOfRSVPAccountFile",
    b"ATTj590743": "mSMQQuota",
    b"ATTj590744": "mSMQBasePriority",
    b"ATTj590745": "mSMQJournalQuota",
    b"ATTj590748": "mSMQPrivacyLevel",
    b"ATTj590754": "mSMQServiceType",
    b"ATTj590759": "mSMQOSType",
    b"ATTj590765": "mSMQLongLived",
    b"ATTj590766": "mSMQVersion",
    b"ATTj590770": "mSMQCost",
    b"ATTj590774": "mSMQServices",
    b"ATTj590784": "mSMQNt4Stub",
    b"ATTj590786": "mSMQQueueQuota",
    b"ATTj590787": "mSMQQueueJournalQuota",
    b"ATTj590788": "mSMQNt4Flags",
    b"ATTj590977": "msRADIUSFramedIPAddress",
    b"ATTj590995": "msRADIUSServiceType",
    b"ATTj591014": "msRASSavedFramedIPAddress",
    b"ATTj591071": "interSiteTopologyRenew",
    b"ATTj591072": "interSiteTopologyFailover",
    b"ATTj591132": "mSMQInterval1",
    b"ATTj591133": "mSMQInterval2",
    b"ATTj591151": "pKIDefaultKeySpec",
    b"ATTj591153": "pKIMaxIssuingDepth",
    b"ATTj591160": "replInterval",
    b"ATTj591168": "dSUIAdminMaximum",
    b"ATTj591169": "dSUIShellMaximum",
    b"ATTj591177": "localizationDisplayId",
    b"ATTj591178": "scopeFlags",
    b"ATTj591180": "validAccesses",
    b"ATTj591185": "mS-DS-ConsistencyChildCount",
    b"ATTj591192": "mS-SQL-Build",
    b"ATTj591194": "mS-SQL-CharacterSet",
    b"ATTj591196": "mS-SQL-UnicodeSortOrder",
    b"ATTj591235": "ms-DS-MachineAccountQuota",
    b"ATTj591253": "msPKI-RA-Signature",
    b"ATTj591254": "msPKI-Enrollment-Flag",
    b"ATTj591255": "msPKI-Private-Key-Flag",
    b"ATTj591256": "msPKI-Certificate-Name-Flag",
    b"ATTj591257": "msPKI-Minimal-Key-Size",
    b"ATTj591258": "msPKI-Template-Schema-Version",
    b"ATTj591259": "msPKI-Template-Minor-Revision",
    b"ATTj591283": "msDS-Behavior-Version",
    b"ATTj591452": "msWMI-IntDefault",
    b"ATTj591453": "msWMI-IntMax",
    b"ATTj591454": "msWMI-IntMin",
    b"ATTj591455": "msWMI-IntValidValues",
    b"ATTj591487": "msDS-Replication-Notify-First-DSA-Delay",
    b"ATTj591488": "msDS-Replication-Notify-Subsequent-DSA-Delay",
    b"ATTj591495": "msPKI-OID-Attribute",
    b"ATTj591501": "msWMI-Genus",
    b"ATTj591502": "msWMI-intFlags1",
    b"ATTj591503": "msWMI-intFlags2",
    b"ATTj591504": "msWMI-intFlags3",
    b"ATTj591505": "msWMI-intFlags4",
    b"ATTj591540": "msDS-IntId",
    b"ATTj591544": "msDS-ReplicationEpoch",
    b"ATTj591608": "msDS-LogonTimeSyncInterval",
    b"ATTj591612": "msDS-PerUserTrustQuota",
    b"ATTj591613": "msDS-AllUsersTrustQuota",
    b"ATTj591614": "msDS-PerUserTrustTombstonesQuota",
    b"ATTj591619": "msDS-AzDomainTimeout",
    b"ATTj591620": "msDS-AzScriptEngineCacheMax",
    b"ATTj591621": "msDS-AzScriptTimeout",
    b"ATTj591624": "msDS-AzOperationID",
    b"ATTj591646": "msieee80211-DataType",
    b"ATTj591648": "msDS-AzMajorVersion",
    b"ATTj591649": "msDS-AzMinorVersion",
    b"ATTj591659": "msDS-Integer",
    b"ATTj591666": "msDs-MaxValues",
    b"ATTj591669": "msDS-QuotaAmount",
    b"ATTj591670": "msDS-DefaultQuota",
    b"ATTj591671": "msDS-TombstoneQuotaFactor",
    b"ATTj591753": "msDS-SecondaryKrbTgtNumber",
    b"ATTj591787": "msDS-SupportedEncryptionTypes",
    b"ATTj591796": "msDS-FailedInteractiveLogonCount",
    b"ATTj591797": "msDS-FailedInteractiveLogonCountAtLastSuccessfulLogon",
    b"ATTj591804": "msTSRemoteControl",
    b"ATTj591805": "msTSMaxDisconnectionTime",
    b"ATTj591806": "msTSMaxConnectionTime",
    b"ATTj591807": "msTSMaxIdleTime",
    b"ATTj591821": "msDS-HABSeniorityIndex",
    b"ATTj591837": "msDS-MinimumPasswordLength",
    b"ATTj591838": "msDS-PasswordHistoryLength",
    b"ATTj591843": "msDS-LockoutThreshold",
    b"ATTj591847": "msDS-PasswordSettingsPrecedence",
    b"ATTj591848": "msDS-NcType",
    b"ATTj591854": "msDFS-SchemaMajorVersion",
    b"ATTj591855": "msDFS-SchemaMinorVersion",
    b"ATTj591859": "msDFS-Ttlv2",
    b"ATTj591887": "msDS-OptionalFeatureFlags",
    b"ATTj591890": "msDS-RequiredDomainBehaviorVersion",
    b"ATTj591892": "msDS-DeletedObjectLifetime",
    b"ATTj591895": "msTSEndpointType",
    b"ATTj591903": "msDS-RequiredForestBehaviorVersion",
    b"ATTj591957": "msDNS-MaintainTrustAnchor",
    b"ATTj591958": "msDNS-DSRecordAlgorithms",
    b"ATTj591960": "msDNS-NSEC3HashAlgorithm",
    b"ATTj591961": "msDNS-NSEC3RandomSaltLength",
    b"ATTj591962": "msDNS-NSEC3Iterations",
    b"ATTj591963": "msDNS-DNSKEYRecordSetTTL",
    b"ATTj591964": "msDNS-DSRecordSetTTL",
    b"ATTj591965": "msDNS-SignatureInceptionOffset",
    b"ATTj591966": "msDNS-SecureDelegationPollingPeriod",
    b"ATTj591971": "msDNS-PropagationTime",
    b"ATTj591997": "msKds-PublicKeyLength",
    b"ATTj591998": "msKds-PrivateKeyLength",
    b"ATTj592000": "msKds-Version",
    b"ATTj592023": "msDS-ManagedPasswordInterval",
    b"ATTj592065": "msDS-RegistrationQuota",
    b"ATTj592066": "msDS-MaximumRegistrationInactivityPeriod",
    b"ATTj592081": "msDS-DeviceObjectVersion",
    b"ATTj592149": "msDS-DeviceTrustType",
    b"ATTj592174": "msDS-StrongNTLMPolicy",
    b"ATTk131081": "helpData32",
    b"ATTk1310860": "userSMIMECertificate",
    b"ATTk131146": "dSASignature",
    b"ATTk131155": "repsTo",
    b"ATTk131163": "repsFrom",
    b"ATTk131187": "invocationId",
    b"ATTk131286": "originalDisplayTableMSDOS",
    b"ATTk131290": "oMObjectClass",
    b"ATTk131327": "addressSyntax",
    b"ATTk131396": "addressEntryDisplayTable",
    b"ATTk131397": "perMsgDialogDisplayTable",
    b"ATTk131398": "perRecipDialogDisplayTable",
    b"ATTk131472": "addressEntryDisplayTableMSDOS",
    b"ATTk131474": "helpData16",
    b"ATTk131517": "originalDisplayTable",
    b"ATTk1376263": "photo",
    b"ATTk1376311": "audio",
    b"ATTk1376316": "jpegPhoto",
    b"ATTk14": "searchGuide",
    b"ATTk1441827": "thumbnailPhoto",
    b"ATTk1441828": "thumbnailLogo",
    b"ATTk1442008": "userPKCS12",
    b"ATTk21": "telexNumber",
    b"ATTk22": "teletexTerminalIdentifier",
    b"ATTk2293762": "msDFSR-Extension",
    b"ATTk2293774": "msDFSR-Schedule",
    b"ATTk2293778": "msDFSR-ContentSetGuid",
    b"ATTk2293783": "msDFSR-ReplicationGroupGuid",
    b"ATTk26": "registeredAddress",
    b"ATTk30": "supportedApplicationContext",
    b"ATTk35": "userPassword",
    b"ATTk36": "userCertificate",
    b"ATTk37": "cACertificate",
    b"ATTk38": "authorityRevocationList",
    b"ATTk39": "certificateRevocationList",
    b"ATTk40": "crossCertificatePair",
    b"ATTk45": "x500uniqueIdentifier",
    b"ATTk53": "deltaRevocationList",
    b"ATTk58": "ATTributeCertificateAttribute",
    b"ATTk589826": "objectGUID",
    b"ATTk589827": "replPropertyMetaData",
    b"ATTk589828": "replUpToDateVector",
    b"ATTk589851": "currentValue",
    b"ATTk589867": "fRSVersionGUID",
    b"ATTk589879": "dBCSPwd",
    b"ATTk589888": "logonHours",
    b"ATTk589889": "logonWorkstation",
    b"ATTk589896": "marshalledInterface",
    b"ATTk589906": "moniker",
    b"ATTk589913": "nTGroupMembers",
    b"ATTk589914": "unicodePwd",
    b"ATTk589918": "ntPwdHistory",
    b"ATTk589924": "priorValue",
    b"ATTk589925": "privateKey",
    b"ATTk589946": "serviceClassID",
    b"ATTk589947": "serviceClassInfo",
    b"ATTk589949": "supplementalCredentials",
    b"ATTk589953": "trustAuthIncoming",
    b"ATTk589959": "trustAuthOutgoing",
    b"ATTk589966": "winsockAddresses",
    b"ATTk589972": "schemaIDGUID",
    b"ATTk589973": "ATTributeSecurityGUID",
    b"ATTk589984": "lmPwdHistory",
    b"ATTk589990": "groupMembershipSAM",
    b"ATTk590023": "serviceInstanceVersion",
    b"ATTk590024": "controlAccessRights",
    b"ATTk590026": "auditingPolicy",
    b"ATTk590029": "pKTGuid",
    b"ATTk590030": "pKT",
    b"ATTk590035": "schedule",
    b"ATTk590092": "eFSPolicy",
    b"ATTk590093": "linkTrackSecret",
    b"ATTk590144": "implementedCategories",
    b"ATTk590145": "requiredCategories",
    b"ATTk590146": "categoryId",
    b"ATTk590156": "birthLocation",
    b"ATTk590157": "oMTIndxGuid",
    b"ATTk590158": "volTableIdxGUID",
    b"ATTk590159": "currentLocation",
    b"ATTk590160": "volTableGUID",
    b"ATTk590161": "currMachineId",
    b"ATTk590180": "foreignIdentifier",
    b"ATTk590183": "netbootGUID",
    b"ATTk590186": "siteGUID",
    b"ATTk590206": "dnsRecord",
    b"ATTk590244": "publicKeyPolicy",
    b"ATTk590245": "domainWidePolicy",
    b"ATTk590283": "machineWidePolicy",
    b"ATTk590329": "oMTGuid",
    b"ATTk590357": "fRSReplicaSetGUID",
    b"ATTk590360": "fRSExtensions",
    b"ATTk590362": "prefixMap",
    b"ATTk590414": "meetingBlob",
    b"ATTk590447": "ipsecData",
    b"ATTk590464": "partialAttributeSet",
    b"ATTk590469": "userCert",
    b"ATTk590487": "partialAttributeDeletionList",
    b"ATTk590497": "retiredReplDSASignatures",
    b"ATTk590507": "cRLPartitionedRevocationList",
    b"ATTk590509": "parentCACertificateChain",
    b"ATTk590516": "previousCACertificates",
    b"ATTk590517": "pendingCACertificates",
    b"ATTk590538": "dhcpOptions",
    b"ATTk590539": "dhcpClasses",
    b"ATTk590542": "dhcpProperties",
    b"ATTk590637": "upgradeProductCode",
    b"ATTk590638": "msiScript",
    b"ATTk590642": "productCode",
    b"ATTk590668": "lDAPIPDenyList",
    b"ATTk590689": "pekList",
    b"ATTk590709": "terminalServer",
    b"ATTk590741": "mSMQQueueType",
    b"ATTk590749": "mSMQOwnerID",
    b"ATTk590751": "mSMQSites",
    b"ATTk590760": "mSMQEncryptKey",
    b"ATTk590761": "mSMQSignKey",
    b"ATTk590771": "mSMQSignCertificates",
    b"ATTk590772": "mSMQDigests",
    b"ATTk590775": "mSMQQMID",
    b"ATTk590777": "mSMQSiteID",
    b"ATTk590790": "mSMQDigestsMig",
    b"ATTk590791": "mSMQSignCertificatesMig",
    b"ATTk591037": "assocNTAccount",
    b"ATTk591129": "moveTreeState",
    b"ATTk591130": "dNSProperty",
    b"ATTk591152": "pKIKeyUsage",
    b"ATTk591155": "pKIExpirationPeriod",
    b"ATTk591156": "pKIOverlapPeriod",
    b"ATTk591161": "mSMQUserSid",
    b"ATTk591182": "schemaInfo",
    b"ATTk591184": "mS-DS-ConsistencyGuid",
    b"ATTk591252": "msCOM-ObjectId",
    b"ATTk591264": "msDs-Schema-Extensions",
    b"ATTk591265": "msDS-Cached-Membership",
    b"ATTk591267": "msDS-Site-Affinity",
    b"ATTk591471": "msWMI-TargetObject",
    b"ATTk591524": "msTAPI-ConferenceBlob",
    b"ATTk591526": "msDS-TrustForestTrustInfo",
    b"ATTk591607": "msDS-ExecuteScriptPassword",
    b"ATTk591645": "msieee80211-Data",
    b"ATTk591650": "msDS-RetiredReplNCSignatures",
    b"ATTk591655": "msDS-ByteArray",
    b"ATTk591667": "msDRM-IdentityCertificate",
    b"ATTk591716": "msPKIRoamingTimeStamp",
    b"ATTk591734": "unixUserPassword",
    b"ATTk591773": "msDS-AzObjectGuid",
    b"ATTk591777": "ms-net-ieee-80211-GP-PolicyReserved",
    b"ATTk591780": "ms-net-ieee-8023-GP-PolicyReserved",
    b"ATTk591789": "msFVE-RecoveryGuid",
    b"ATTk591793": "samDomainUpdates",
    b"ATTk591822": "msFVE-VolumeGuid",
    b"ATTk591823": "msFVE-KeyPackage",
    b"ATTk591856": "msDFS-GenerationGUIDv2",
    b"ATTk591857": "msDFS-NamespaceIdentityGUIDv2",
    b"ATTk591862": "msDFS-TargetListv2",
    b"ATTk591865": "msDFS-LinkIdentityGUIDv2",
    b"ATTk591877": "msImaging-PSPIdentifier",
    b"ATTk591886": "msDS-OptionalFeatureGUID",
    b"ATTk591905": "msSPP-CSVLKSkuId",
    b"ATTk591906": "msSPP-KMSIds",
    b"ATTk591909": "msSPP-OnlineLicense",
    b"ATTk591910": "msSPP-PhoneLicense",
    b"ATTk591911": "msSPP-ConfigLicense",
    b"ATTk591912": "msSPP-IssuanceLicense",
    b"ATTk591931": "msTPM-SrkPubThumbprint",
    b"ATTk591967": "msDNS-SigningKeyDescriptors",
    b"ATTk591968": "msDNS-SigningKeys",
    b"ATTk591969": "msDNS-DNSKEYRecords",
    b"ATTk591990": "msDS-GenerationId",
    b"ATTk591994": "msKds-KDFParam",
    b"ATTk591996": "msKds-SecretAgreementParam",
    b"ATTk591999": "msKds-RootKeyData",
    b"ATTk592004": "msImaging-ThumbprintHash",
    b"ATTk592014": "msDS-TransformationRulesCompiled",
    b"ATTk592021": "msDS-ManagedPasswordId",
    b"ATTk592022": "msDS-ManagedPasswordPreviousId",
    b"ATTk592058": "netbootDUID",
    b"ATTk592064": "msDS-IssuerCertificates",
    b"ATTk592076": "msDS-DeviceID",
    b"ATTk592082": "msDS-RegisteredOwner",
    b"ATTk592087": "msDS-RegisteredUsers",
    b"ATTk592093": "msDS-IssuerPublicCertificates",
    b"ATTk592097": "msDS-CloudAnchor",
    b"ATTk592098": "msDS-CloudIssuerPublicCertificates",
    b"ATTk592101": "msDS-UserAllowedToAuthenticateTo",
    b"ATTk592102": "msDS-UserAllowedToAuthenticateFrom",
    b"ATTk592104": "msDS-ComputerAllowedToAuthenticateTo",
    b"ATTk592106": "msDS-ServiceAllowedToAuthenticateTo",
    b"ATTk592107": "msDS-ServiceAllowedToAuthenticateFrom",
    b"ATTk592139": "msDS-KeyId",
    b"ATTk592140": "msDS-KeyMaterial",
    b"ATTk592146": "msDS-CustomKeyInformation",
    b"ATTl131074": "whenCreated",
    b"ATTl131075": "whenChanged",
    b"ATTl590305": "schemaUpdate",
    b"ATTl590411": "meetingStartTime",
    b"ATTl590412": "meetingEndTime",
    b"ATTl590704": "fRSTimeLastCommand",
    b"ATTl590705": "fRSTimeLastConfigChange",
    b"ATTl591181": "dSCorePropagationData",
    b"ATTl591446": "msDS-Entry-Time-To-Die",
    b"ATTl591656": "msDS-DateTime",
    b"ATTl591817": "msTSExpireDate",
    b"ATTl591824": "msTSExpireDate2",
    b"ATTl591827": "msTSExpireDate3",
    b"ATTl591830": "msTSExpireDate4",
    b"ATTl591858": "msDFS-LastModifiedv2",
    b"ATTm10": "o",
    b"ATTm11": "ou",
    b"ATTm12": "title",
    b"ATTm13": "description",
    b"ATTm131085": "displayName",
    b"ATTm131090": "otherTelephone",
    b"ATTm131153": "info",
    b"ATTm131190": "otherPager",
    b"ATTm131203": "co",
    b"ATTm131213": "department",
    b"ATTm131218": "company",
    b"ATTm131266": "adminDisplayName",
    b"ATTm131282": "proxyAddresses",
    b"ATTm131284": "dSHeuristics",
    b"ATTm131298": "adminDescription",
    b"ATTm131299": "extensionName",
    b"ATTm131328": "streetAddress",
    b"ATTm131349": "otherHomePhone",
    b"ATTm131399": "helpFileName",
    b"ATTm131516": "msExchAssistantName",
    b"ATTm131532": "lDAPDisplayName",
    b"ATTm131536": "wWWHomePage",
    b"ATTm131665": "msExchLabeledURI",
    b"ATTm131668": "msExchHouseIdentifier",
    b"ATTm131670": "dmdName",
    b"ATTm131682": "employeeNumber",
    b"ATTm131685": "employeeType",
    b"ATTm131687": "personalTitle",
    b"ATTm131689": "homePostalAddress",
    b"ATTm1376257": "uid",
    b"ATTm1376258": "textEncodedORAddress",
    b"ATTm1376259": "mail",
    b"ATTm1376261": "drink",
    b"ATTm1376262": "roomNumber",
    b"ATTm1376264": "userClass",
    b"ATTm1376265": "host",
    b"ATTm1376267": "documentIdentifier",
    b"ATTm1376268": "documentTitle",
    b"ATTm1376269": "documentVersion",
    b"ATTm1376271": "documentLocation",
    b"ATTm1376276": "homePhone",
    b"ATTm1376281": "dc",
    b"ATTm1376297": "mobile",
    b"ATTm1376298": "pager",
    b"ATTm1376300": "uniqueIdentifier",
    b"ATTm1376301": "organizationalStatus",
    b"ATTm1376304": "buildingName",
    b"ATTm1376312": "documentPublisher",
    b"ATTm1441793": "carLicense",
    b"ATTm1441794": "departmentNumber",
    b"ATTm1441826": "middleName",
    b"ATTm1441831": "preferredLanguage",
    b"ATTm15": "businessCategory",
    b"ATTm16": "postalAddress",
    b"ATTm17": "postalCode",
    b"ATTm18": "postOfficeBox",
    b"ATTm19": "physicalDeliveryOfficeName",
    b"ATTm1900601": "labeledURI",
    b"ATTm1966088": "unstructuredAddress",
    b"ATTm20": "telephoneNumber",
    b"ATTm2162988": "msSFU30SearchContainer",
    b"ATTm2162989": "msSFU30KeyAttributes",
    b"ATTm2162990": "msSFU30FieldSeparator",
    b"ATTm2162991": "msSFU30IntraFieldSeparator",
    b"ATTm2162992": "msSFU30SearchAttributes",
    b"ATTm2162993": "msSFU30ResultAttributes",
    b"ATTm2162994": "msSFU30MapFilter",
    b"ATTm2162995": "msSFU30MasterServerName",
    b"ATTm2162996": "msSFU30OrderNumber",
    b"ATTm2293761": "msDFSR-Version",
    b"ATTm2293763": "msDFSR-RootPath",
    b"ATTm2293765": "msDFSR-StagingPath",
    b"ATTm2293767": "msDFSR-ConflictPath",
    b"ATTm2293772": "msDFSR-FileFilter",
    b"ATTm2293773": "msDFSR-DirectoryFilter",
    b"ATTm2293775": "msDFSR-Keywords",
    b"ATTm2293781": "msDFSR-DfsPath",
    b"ATTm2293784": "msDFSR-DfsLinkTarget",
    b"ATTm2293786": "msDFSR-DeletedPath",
    b"ATTm2293794": "msDFSR-DefaultCompressionExclusionFilter",
    b"ATTm2293795": "msDFSR-OnDemandExclusionFileFilter",
    b"ATTm2293796": "msDFSR-OnDemandExclusionDirectoryFilter",
    b"ATTm2293798": "msDFSR-CommonStagingPath",
    b"ATTm23": "facsimileTelephoneNumber",
    b"ATTm3": "cn",
    b"ATTm4": "sn",
    b"ATTm42": "givenName",
    b"ATTm43": "initials",
    b"ATTm44": "generationQualifier",
    b"ATTm51": "houseIdentifier",
    b"ATTm589825": "name",
    b"ATTm589839": "msiScriptPath",
    b"ATTm589843": "cOMClassID",
    b"ATTm589844": "cOMInterfaceID",
    b"ATTm589845": "cOMProgID",
    b"ATTm589852": "dnsRoot",
    b"ATTm589859": "employeeID",
    b"ATTm589868": "homeDirectory",
    b"ATTm589869": "homeDrive",
    b"ATTm589872": "keywords",
    b"ATTm589886": "scriptPath",
    b"ATTm589907": "monikerDisplayName",
    b"ATTm589910": "userWorkstations",
    b"ATTm589911": "nETBIOSName",
    b"ATTm589915": "otherLoginWorkstations",
    b"ATTm589929": "remoteServerName",
    b"ATTm589931": "remoteSource",
    b"ATTm589933": "replicaSource",
    b"ATTm589937": "rpcNsBindings",
    b"ATTm589938": "rpcNsGroup",
    b"ATTm589939": "rpcNsInterfaceID",
    b"ATTm589942": "rpcNsProfileEntry",
    b"ATTm589957": "trustPartner",
    b"ATTm589961": "uNCName",
    b"ATTm589962": "userParameters",
    b"ATTm589963": "profilePath",
    b"ATTm589975": "oEMInformation",
    b"ATTm589980": "comment",
    b"ATTm589982": "domainReplica",
    b"ATTm590042": "applicationName",
    b"ATTm590043": "iconPath",
    b"ATTm590045": "sAMAccountName",
    b"ATTm590046": "location",
    b"ATTm590047": "serverName",
    b"ATTm590048": "defaultSecurityDescriptor",
    b"ATTm590052": "portName",
    b"ATTm590053": "driverName",
    b"ATTm590054": "printSeparatorFile",
    b"ATTm590059": "printFormName",
    b"ATTm590061": "printBinNames",
    b"ATTm590064": "printOrientationsSupported",
    b"ATTm590070": "printLanguage",
    b"ATTm590073": "cOMCLSID",
    b"ATTm590074": "cOMUniqueLIBID",
    b"ATTm590075": "cOMTreatAsClassId",
    b"ATTm590077": "cOMOtherProgId",
    b"ATTm590078": "cOMTypelibId",
    b"ATTm590079": "vendor",
    b"ATTm590085": "division",
    b"ATTm590089": "notes",
    b"ATTm590094": "printShareName",
    b"ATTm590095": "printOwner",
    b"ATTm590096": "printNotify",
    b"ATTm590097": "printStatus",
    b"ATTm590098": "printSpooling",
    b"ATTm590107": "assetNumber",
    b"ATTm590110": "printRateUnit",
    b"ATTm590111": "printNetworkAddress",
    b"ATTm590112": "printMACAddress",
    b"ATTm590113": "printMediaReady",
    b"ATTm590123": "printMediaSupported",
    b"ATTm590124": "printerName",
    b"ATTm590125": "wbemPath",
    b"ATTm590136": "rpcNsObjectID",
    b"ATTm590138": "rpcNsTransferSyntax",
    b"ATTm590149": "setupCommand",
    b"ATTm590150": "packageName",
    b"ATTm590154": "lastUpdateSequence",
    b"ATTm590164": "rightsGuid",
    b"ATTm590165": "appliesTo",
    b"ATTm590168": "groupsToIgnore",
    b"ATTm590169": "groupPriority",
    b"ATTm590170": "desktopProfile",
    b"ATTm590182": "netbootInitialization",
    b"ATTm590185": "netbootMachineFilePath",
    b"ATTm590187": "operatingSystem",
    b"ATTm590188": "operatingSystemVersion",
    b"ATTm590189": "operatingSystemServicePack",
    b"ATTm590190": "rpcNsAnnotation",
    b"ATTm590191": "rpcNsCodeset",
    b"ATTm590239": "operatingSystemHotfix",
    b"ATTm590307": "fRSFileFilter",
    b"ATTm590308": "fRSDirectoryFilter",
    b"ATTm590310": "fRSWorkingPath",
    b"ATTm590311": "fRSRootPath",
    b"ATTm590312": "fRSStagingPath",
    b"ATTm590315": "fRSFaultCondition",
    b"ATTm590322": "creationWizard",
    b"ATTm590323": "contextMenu",
    b"ATTm590324": "fRSServiceCommand",
    b"ATTm590333": "serviceClassName",
    b"ATTm590334": "serviceBindingInformation",
    b"ATTm590335": "flatName",
    b"ATTm590356": "superiorDNSRoot",
    b"ATTm590363": "initialAuthIncoming",
    b"ATTm590364": "initialAuthOutgoing",
    b"ATTm590386": "adminPropertyPages",
    b"ATTm590387": "shellPropertyPages",
    b"ATTm590389": "meetingID",
    b"ATTm590390": "meetingName",
    b"ATTm590391": "meetingDescription",
    b"ATTm590392": "meetingKeyword",
    b"ATTm590393": "meetingLocation",
    b"ATTm590394": "meetingProtocol",
    b"ATTm590395": "meetingType",
    b"ATTm590397": "meetingApplication",
    b"ATTm590398": "meetingLanguage",
    b"ATTm590401": "meetingOriginator",
    b"ATTm590402": "meetingContactInfo",
    b"ATTm590403": "meetingOwner",
    b"ATTm590404": "meetingIP",
    b"ATTm590405": "meetingScope",
    b"ATTm590406": "meetingAdvertiseScope",
    b"ATTm590407": "meetingURL",
    b"ATTm590408": "meetingRating",
    b"ATTm590409": "meetingIsEncrypted",
    b"ATTm590410": "meetingRecurrence",
    b"ATTm590434": "classDisplayName",
    b"ATTm590438": "adminContextMenu",
    b"ATTm590439": "shellContextMenu",
    b"ATTm590443": "dNSHostName",
    b"ATTm590444": "ipsecName",
    b"ATTm590445": "ipsecID",
    b"ATTm590458": "privilegeDisplayName",
    b"ATTm590470": "otherFacsimileTelephoneNumber",
    b"ATTm590471": "otherMobile",
    b"ATTm590472": "primaryTelexNumber",
    b"ATTm590473": "primaryInternationalISDNNumber",
    b"ATTm590474": "mhsORAddress",
    b"ATTm590475": "otherMailbox",
    b"ATTm590480": "userPrincipalName",
    b"ATTm590481": "serviceDNSName",
    b"ATTm590483": "serviceDNSNameType",
    b"ATTm590484": "treeName",
    b"ATTm590495": "msiFileList",
    b"ATTm590496": "categories",
    b"ATTm590499": "catalogs",
    b"ATTm590503": "creator",
    b"ATTm590504": "queryPoint",
    b"ATTm590505": "indexedScopes",
    b"ATTm590506": "friendlyNames",
    b"ATTm590511": "cAConnect",
    b"ATTm590512": "cAWEBURL",
    b"ATTm590514": "cAUsages",
    b"ATTm590521": "cACertificateDN",
    b"ATTm590525": "dhcpIdentification",
    b"ATTm590526": "dhcpObjName",
    b"ATTm590527": "dhcpObjDescription",
    b"ATTm590535": "superScopeDescription",
    b"ATTm590536": "optionDescription",
    b"ATTm590545": "ipPhone",
    b"ATTm590546": "otherIpPhone",
    b"ATTm590572": "ATTributeDisplayNames",
    b"ATTm590573": "url",
    b"ATTm590575": "userSharedFolder",
    b"ATTm590576": "userSharedFolderOther",
    b"ATTm590580": "aCSTimeOfDay",
    b"ATTm590595": "servicePrincipalName",
    b"ATTm590596": "aCSPolicyName",
    b"ATTm590597": "aCSRSVPLogFilesLocation",
    b"ATTm590608": "aCSIdentityName",
    b"ATTm590610": "mailAddress",
    b"ATTm590613": "transportDLLName",
    b"ATTm590633": "remoteStorageGUID",
    b"ATTm590634": "createDialog",
    b"ATTm590636": "createWizardExt",
    b"ATTm590639": "canUpgradeScript",
    b"ATTm590640": "fileExtPriority",
    b"ATTm590641": "localizedDescription",
    b"ATTm590647": "certificateTemplates",
    b"ATTm590648": "signatureAlgorithms",
    b"ATTm590649": "enrollmentProviders",
    b"ATTm590667": "lDAPAdminLimits",
    b"ATTm590669": "msiScriptName",
    b"ATTm590679": "netbootNewMachineNamingPolicy",
    b"ATTm590681": "netbootIntelliMirrorOSes",
    b"ATTm590682": "netbootTools",
    b"ATTm590683": "netbootLocallyInstalledOSes",
    b"ATTm590691": "altSecurityIdentities",
    b"ATTm590695": "fRSControlDataCreation",
    b"ATTm590696": "fRSControlInboundBacklog",
    b"ATTm590697": "fRSControlOutboundBacklog",
    b"ATTm590703": "fRSServiceCommandStatus",
    b"ATTm590706": "fRSVersion",
    b"ATTm590707": "msRRASVendorAttributeEntry",
    b"ATTm590708": "msRRASAttribute",
    b"ATTm590710": "purportedSearch",
    b"ATTm590711": "iPSECNegotiationPolicyType",
    b"ATTm590712": "iPSECNegotiationPolicyAction",
    b"ATTm590713": "additionalTrustedServiceNames",
    b"ATTm590714": "uPNSuffixes",
    b"ATTm590715": "gPLink",
    b"ATTm590718": "gPCFileSysPath",
    b"ATTm590724": "aCSRSVPAccountFilesLocation",
    b"ATTm591033": "shortServerName",
    b"ATTm591064": "netbootSIFFile",
    b"ATTm591065": "netbootMirrorDataFile",
    b"ATTm591067": "mSMQQueueNameExt",
    b"ATTm591131": "accountNameHistory",
    b"ATTm591136": "aCSServerList",
    b"ATTm591154": "pKICriticalExtensions",
    b"ATTm591157": "pKIExtendedKeyUsage",
    b"ATTm591158": "pKIDefaultCSPs",
    b"ATTm591167": "dSUIAdminNotification",
    b"ATTm591171": "sPNMappings",
    b"ATTm591172": "gPCMachineExtensionNames",
    b"ATTm591173": "gPCUserExtensionNames",
    b"ATTm591179": "queryFilter",
    b"ATTm591187": "mS-SQL-Name",
    b"ATTm591188": "mS-SQL-RegisteredOwner",
    b"ATTm591189": "mS-SQL-Contact",
    b"ATTm591190": "mS-SQL-Location",
    b"ATTm591193": "mS-SQL-ServiceAccount",
    b"ATTm591195": "mS-SQL-SortOrder",
    b"ATTm591198": "mS-SQL-NamedPipe",
    b"ATTm591199": "mS-SQL-MultiProtocol",
    b"ATTm591200": "mS-SQL-SPX",
    b"ATTm591201": "mS-SQL-TCPIP",
    b"ATTm591202": "mS-SQL-AppleTalk",
    b"ATTm591203": "mS-SQL-Vines",
    b"ATTm591205": "mS-SQL-LastUpdatedDate",
    b"ATTm591206": "mS-SQL-InformationURL",
    b"ATTm591207": "mS-SQL-ConnectionURL",
    b"ATTm591208": "mS-SQL-PublicationURL",
    b"ATTm591209": "mS-SQL-GPSLatitude",
    b"ATTm591210": "mS-SQL-GPSLongitude",
    b"ATTm591211": "mS-SQL-GPSHeight",
    b"ATTm591212": "mS-SQL-Version",
    b"ATTm591213": "mS-SQL-Language",
    b"ATTm591214": "mS-SQL-Description",
    b"ATTm591215": "mS-SQL-Type",
    b"ATTm591217": "mS-SQL-Database",
    b"ATTm591219": "mS-SQL-Alias",
    b"ATTm591221": "mS-SQL-CreationDate",
    b"ATTm591222": "mS-SQL-LastBackupDate",
    b"ATTm591223": "mS-SQL-LastDiagnosticDate",
    b"ATTm591224": "mS-SQL-Applications",
    b"ATTm591225": "mS-SQL-Keywords",
    b"ATTm591226": "mS-SQL-Publisher",
    b"ATTm591239": "mSMQLabelEx",
    b"ATTm591240": "mSMQSiteNameEx",
    b"ATTm591241": "mSMQComputerTypeEx",
    b"ATTm591260": "msPKI-Cert-Template-OID",
    b"ATTm591261": "msPKI-Supersede-Templates",
    b"ATTm591262": "msPKI-RA-Policies",
    b"ATTm591263": "msPKI-Certificate-Policy",
    b"ATTm591445": "msDS-Other-Settings",
    b"ATTm591447": "msWMI-Author",
    b"ATTm591448": "msWMI-ChangeDate",
    b"ATTm591449": "msWMI-ClassDefinition",
    b"ATTm591450": "msWMI-CreationDate",
    b"ATTm591451": "msWMI-ID",
    b"ATTm591460": "msWMI-StringDefault",
    b"ATTm591461": "msWMI-StringValidValues",
    b"ATTm591462": "msWMI-Mof",
    b"ATTm591463": "msWMI-Name",
    b"ATTm591464": "msWMI-NormalizedClass",
    b"ATTm591465": "msWMI-PropertyName",
    b"ATTm591466": "msWMI-Query",
    b"ATTm591467": "msWMI-QueryLanguage",
    b"ATTm591468": "msWMI-SourceOrganization",
    b"ATTm591469": "msWMI-TargetClass",
    b"ATTm591470": "msWMI-TargetNameSpace",
    b"ATTm591472": "msWMI-TargetPath",
    b"ATTm591473": "msWMI-TargetType",
    b"ATTm591496": "msPKI-OID-CPS",
    b"ATTm591497": "msPKI-OID-User-Notice",
    b"ATTm591498": "msPKI-Certificate-Application-Policy",
    b"ATTm591499": "msPKI-RA-Application-Policies",
    b"ATTm591500": "msWMI-Class",
    b"ATTm591506": "msWMI-Parm1",
    b"ATTm591507": "msWMI-Parm2",
    b"ATTm591508": "msWMI-Parm3",
    b"ATTm591509": "msWMI-Parm4",
    b"ATTm591510": "msWMI-ScopeGuid",
    b"ATTm591511": "extraColumns",
    b"ATTm591512": "msDS-Security-Group-Extra-Classes",
    b"ATTm591513": "msDS-Non-Security-Group-Extra-Classes",
    b"ATTm591514": "adminMultiselectPropertyPages",
    b"ATTm591516": "msFRS-Topology-Pref",
    b"ATTm591518": "gPCWQLFilter",
    b"ATTm591519": "msMQ-Recipient-FormatName",
    b"ATTm591521": "msDS-Settings",
    b"ATTm591522": "msTAPI-uid",
    b"ATTm591523": "msTAPI-ProtocolId",
    b"ATTm591525": "msTAPI-IpAddress",
    b"ATTm591527": "msDS-FilterContainers",
    b"ATTm591534": "msDS-AllowedDNSSuffixes",
    b"ATTm591536": "msPKI-OIDLocalizedName",
    b"ATTm591538": "MSMQ-MulticastAddress",
    b"ATTm591539": "msDS-SPNSuffixes",
    b"ATTm591541": "msDS-AdditionalDnsHostName",
    b"ATTm591542": "msDS-AdditionalSamAccountName",
    b"ATTm591543": "msDS-DnsRootAlias",
    b"ATTm591545": "msDS-UpdateScript",
    b"ATTm591609": "msIIS-FTPRoot",
    b"ATTm591610": "msIIS-FTPDir",
    b"ATTm591611": "msDS-AllowedToDelegateTo",
    b"ATTm591616": "msDS-AzLDAPQuery",
    b"ATTm591622": "msDS-AzApplicationName",
    b"ATTm591623": "msDS-AzScopeName",
    b"ATTm591625": "msDS-AzBizRule",
    b"ATTm591626": "msDS-AzBizRuleLanguage",
    b"ATTm591627": "msDS-AzLastImportedBizRulePath",
    b"ATTm591640": "msDS-AzClassId",
    b"ATTm591641": "msDS-AzApplicationVersion",
    b"ATTm591643": "msDS-AzApplicationData",
    b"ATTm591647": "msieee80211-ID",
    b"ATTm591657": "msDS-ExternalKey",
    b"ATTm591658": "msDS-ExternalStore",
    b"ATTm591703": "msDS-SourceObjectDN",
    b"ATTm591766": "msDS-PhoneticFirstName",
    b"ATTm591767": "msDS-PhoneticLastName",
    b"ATTm591768": "msDS-PhoneticDepartment",
    b"ATTm591769": "msDS-PhoneticCompanyName",
    b"ATTm591770": "msDS-PhoneticDisplayName",
    b"ATTm591774": "msDS-AzGenericData",
    b"ATTm591775": "ms-net-ieee-80211-GP-PolicyGUID",
    b"ATTm591776": "ms-net-ieee-80211-GP-PolicyData",
    b"ATTm591778": "ms-net-ieee-8023-GP-PolicyGUID",
    b"ATTm591779": "ms-net-ieee-8023-GP-PolicyData",
    b"ATTm591786": "msDS-PromotionSettings",
    b"ATTm591788": "msFVE-RecoveryPassword",
    b"ATTm591790": "msTPM-OwnerInformation",
    b"ATTm591800": "msTSProfilePath",
    b"ATTm591801": "msTSHomeDirectory",
    b"ATTm591802": "msTSHomeDrive",
    b"ATTm591813": "msTSWorkDirectory",
    b"ATTm591814": "msTSInitialProgram",
    b"ATTm591815": "msTSProperty01",
    b"ATTm591816": "msTSProperty02",
    b"ATTm591818": "msTSLicenseVersion",
    b"ATTm591819": "msTSManagingLS",
    b"ATTm591825": "msTSLicenseVersion2",
    b"ATTm591826": "msTSManagingLS2",
    b"ATTm591828": "msTSLicenseVersion3",
    b"ATTm591829": "msTSManagingLS3",
    b"ATTm591831": "msTSLicenseVersion4",
    b"ATTm591832": "msTSManagingLS4",
    b"ATTm591833": "msTSLSProperty01",
    b"ATTm591834": "msTSLSProperty02",
    b"ATTm591860": "msDFS-Commentv2",
    b"ATTm591861": "msDFS-Propertiesv2",
    b"ATTm591863": "msDFS-LinkPathv2",
    b"ATTm591866": "msDFS-ShortNameLinkPathv2",
    b"ATTm591878": "msImaging-PSPString",
    b"ATTm591891": "msDS-LastKnownRDN",
    b"ATTm591894": "msTSEndpointData",
    b"ATTm591896": "msTSEndpointPlugin",
    b"ATTm591900": "msPKI-Enrollment-Servers",
    b"ATTm591901": "msPKI-Site-Name",
    b"ATTm591907": "msSPP-InstallationId",
    b"ATTm591908": "msSPP-ConfirmationId",
    b"ATTm591921": "msDS-ClaimPossibleValues",
    b"ATTm591929": "msSPP-CSVLKPid",
    b"ATTm591930": "msSPP-CSVLKPartialProductKey",
    b"ATTm591932": "msTPM-OwnerInformationTemp",
    b"ATTm591952": "msDNS-KeymasterZones",
    b"ATTm591972": "msDNS-NSEC3UserSalt",
    b"ATTm591973": "msDNS-NSEC3CurrentSalt",
    b"ATTm591974": "msAuthz-EffectiveSecurityPolicy",
    b"ATTm591975": "msAuthz-ProposedSecurityPolicy",
    b"ATTm591976": "msAuthz-LastEffectiveSecurityPolicy",
    b"ATTm591977": "msAuthz-ResourceCondition",
    b"ATTm591981": "msDS-ClaimSource",
    b"ATTm591982": "msDS-ClaimSourceType",
    b"ATTm591993": "msKds-KDFAlgorithmID",
    b"ATTm591995": "msKds-SecretAgreementAlgorithmID",
    b"ATTm592005": "msImaging-HashAlgorithm",
    b"ATTm592013": "msDS-TransformationRules",
    b"ATTm592019": "msDS-AppliesToResourceTypes",
    b"ATTm592038": "msDS-cloudExtensionAttribute1",
    b"ATTm592039": "msDS-cloudExtensionAttribute2",
    b"ATTm592040": "msDS-cloudExtensionAttribute3",
    b"ATTm592041": "msDS-cloudExtensionAttribute4",
    b"ATTm592042": "msDS-cloudExtensionAttribute5",
    b"ATTm592043": "msDS-cloudExtensionAttribute6",
    b"ATTm592044": "msDS-cloudExtensionAttribute7",
    b"ATTm592045": "msDS-cloudExtensionAttribute8",
    b"ATTm592046": "msDS-cloudExtensionAttribute9",
    b"ATTm592047": "msDS-cloudExtensionAttribute10",
    b"ATTm592048": "msDS-cloudExtensionAttribute11",
    b"ATTm592049": "msDS-cloudExtensionAttribute12",
    b"ATTm592050": "msDS-cloudExtensionAttribute13",
    b"ATTm592051": "msDS-cloudExtensionAttribute14",
    b"ATTm592052": "msDS-cloudExtensionAttribute15",
    b"ATTm592053": "msDS-cloudExtensionAttribute16",
    b"ATTm592054": "msDS-cloudExtensionAttribute17",
    b"ATTm592055": "msDS-cloudExtensionAttribute18",
    b"ATTm592056": "msDS-cloudExtensionAttribute19",
    b"ATTm592057": "msDS-cloudExtensionAttribute20",
    b"ATTm592073": "msDS-DeviceOSType",
    b"ATTm592074": "msDS-DeviceOSVersion",
    b"ATTm592075": "msDS-DevicePhysicalIDs",
    b"ATTm592089": "msDS-DrsFarmID",
    b"ATTm592100": "msDS-SyncServerUrl",
    b"ATTm592132": "msDS-DeviceMDMStatus",
    b"ATTm592134": "msDS-ExternalDirectoryObjectId",
    b"ATTm592141": "msDS-KeyUsage",
    b"ATTm592144": "msDS-DeviceDN",
    b"ATTm592176": "msDS-SourceAnchor",
    b"ATTm592177": "msDS-ObjectSoa",
    b"ATTm592190": "msDS-preferredDataLocation",
    b"ATTm6": "c",
    b"ATTm7": "l",
    b"ATTm8": "st",
    b"ATTm9": "street",
    b"ATTn29": "presentationAddress",
    b"ATTp131353": "nTSecurityDescriptor",
    b"ATTp590359": "fRSRootSecurity",
    b"ATTp591159": "pKIEnrollmentAccess",
    b"ATTp591864": "msDFS-LinkSecurityDescriptorv2",
    b"ATTp592006": "msDS-AllowedToActOnBehalfOfOtherIdentity",
    b"ATTp592024": "msDS-GroupMSAMembership",
    b"ATTq131091": "uSNCreated",
    b"ATTq131192": "uSNChanged",
    b"ATTq131193": "uSNLastObjRem",
    b"ATTq131339": "uSNDSALastObjRemoved",
    b"ATTq2293764": "msDFSR-RootSizeInMb",
    b"ATTq2293766": "msDFSR-StagingSizeInMb",
    b"ATTq2293768": "msDFSR-ConflictSizeInMb",
    b"ATTq2293780": "msDFSR-RdcMinFileSizeInKb",
    b"ATTq2293787": "msDFSR-DeletedSizeInMb",
    b"ATTq2293799": "msDFSR-CommonStagingSizeInMb",
    b"ATTq589837": "builtinCreationTime",
    b"ATTq589838": "builtinModifiedCount",
    b"ATTq589850": "creationTime",
    b"ATTq589863": "forceLogoff",
    b"ATTq589873": "badPasswordTime",
    b"ATTq589874": "lastContentIndexed",
    b"ATTq589875": "lastLogoff",
    b"ATTq589876": "lastLogon",
    b"ATTq589877": "lastSetTime",
    b"ATTq589884": "lockoutDuration",
    b"ATTq589885": "lockOutObservationWindow",
    b"ATTq589890": "lSACreationTime",
    b"ATTq589891": "lSAModifiedCount",
    b"ATTq589898": "maxPwdAge",
    b"ATTq589899": "maxRenewAge",
    b"ATTq589900": "maxStorage",
    b"ATTq589901": "maxTicketAge",
    b"ATTq589902": "minPwdAge",
    b"ATTq589904": "minTicketAge",
    b"ATTq589905": "modifiedCountAtLastProm",
    b"ATTq589920": "pwdLastSet",
    b"ATTq589923": "priorSetTime",
    b"ATTq589927": "proxyLifetime",
    b"ATTq589983": "accountExpires",
    b"ATTq589992": "modifiedCount",
    b"ATTq590194": "rIDAvailablePool",
    b"ATTq590195": "rIDAllocationPool",
    b"ATTq590196": "rIDPreviousAllocationPool",
    b"ATTq590197": "rIDUsedPool",
    b"ATTq590326": "timeVolChange",
    b"ATTq590327": "timeRefresh",
    b"ATTq590343": "lastBackupRestorationTime",
    b"ATTq590344": "machinePasswordChangeInterval",
    b"ATTq590459": "privilegeValue",
    b"ATTq590486": "lockoutTime",
    b"ATTq590522": "dhcpUniqueKey",
    b"ATTq590524": "dhcpFlags",
    b"ATTq590543": "dhcpMaxKey",
    b"ATTq590544": "dhcpUpdateTime",
    b"ATTq590582": "aCSMaxTokenRatePerFlow",
    b"ATTq590583": "aCSMaxPeakBandwidthPerFlow",
    b"ATTq590584": "aCSAggregateTokenRatePerUser",
    b"ATTq590589": "aCSPermissionBits",
    b"ATTq590590": "aCSAllocableRSVPBandwidth",
    b"ATTq590591": "aCSMaxPeakBandwidth",
    b"ATTq590604": "aCSNonReservedTxLimit",
    b"ATTq590690": "pekKeyChangeInterval",
    b"ATTq590720": "uSNSource",
    b"ATTq590721": "aCSMaxAggregatePeakRatePerUser",
    b"ATTq590722": "aCSNonReservedTxSize",
    b"ATTq591137": "aCSMaxTokenBucketPerFlow",
    b"ATTq591138": "aCSMaximumSDUSize",
    b"ATTq591139": "aCSMinimumPolicedSize",
    b"ATTq591140": "aCSMinimumLatency",
    b"ATTq591141": "aCSMinimumDelayVariation",
    b"ATTq591142": "aCSNonReservedPeakRate",
    b"ATTq591143": "aCSNonReservedTokenSize",
    b"ATTq591144": "aCSNonReservedMaxSDUSize",
    b"ATTq591145": "aCSNonReservedMinPolicedSize",
    b"ATTq591191": "mS-SQL-Memory",
    b"ATTq591204": "mS-SQL-Status",
    b"ATTq591220": "mS-SQL-Size",
    b"ATTq591266": "msDS-Cached-Membership-Time-Stamp",
    b"ATTq591456": "msWMI-Int8Default",
    b"ATTq591457": "msWMI-Int8Max",
    b"ATTq591458": "msWMI-Int8Min",
    b"ATTq591459": "msWMI-Int8ValidValues",
    b"ATTq591520": "lastLogonTimestamp",
    b"ATTq591794": "msDS-LastSuccessfulInteractiveLogonTime",
    b"ATTq591795": "msDS-LastFailedInteractiveLogonTime",
    b"ATTq591835": "msDS-MaximumPasswordAge",
    b"ATTq591836": "msDS-MinimumPasswordAge",
    b"ATTq591841": "msDS-LockoutObservationWindow",
    b"ATTq591842": "msDS-LockoutDuration",
    b"ATTq591879": "msDS-USNLastSyncSuccess",
    b"ATTq591922": "msDS-ClaimValueType",
    b"ATTq592002": "msKds-UseStartTime",
    b"ATTq592003": "msKds-CreateTime",
    b"ATTq592007": "msDS-GeoCoordinatesAltitude",
    b"ATTq592008": "msDS-GeoCoordinatesLatitude",
    b"ATTq592009": "msDS-GeoCoordinatesLongitude",
    b"ATTq592086": "msDS-ApproximateLastLogonTimeStamp",
    b"ATTq592103": "msDS-UserTGTLifetime",
    b"ATTq592105": "msDS-ComputerTGTLifetime",
    b"ATTq592108": "msDS-ServiceTGTLifetime",
    b"ATTq592147": "msDS-KeyApproximateLastLogonTimeStamp",
    b"ATTr589945": "securityIdentifier",
    b"ATTr589970": "objectSid",
    b"ATTr590433": "sIDHistory",
    b"ATTr590491": "syncWithSID",
    b"ATTr591234": "mS-DS-CreatorSID",
    b"ATTr591668": "msDS-QuotaTrustee",
    b"ATTr591978": "msAuthz-CentralAccessPolicyID",
    b"ATTr592145": "msDS-ComputerSID",
    b"ATTr592148": "msDS-ShadowPrincipalSid",
}

ESENT_TO_LDAP_DECODED = {k.decode(): v for k, v in ESENT_TO_LDAP.items()}

# ! No longer needed since we can programmatically generate the attr ID/name combos
# ! Though it is still available for backwards-compatibility, plus I don't feel refactoring yet
NAME_TO_INTERNAL = {v: k for k, v in ESENT_TO_LDAP.items()}
NAME_TO_INTERNAL_DECODED = {k: v.decode() for k, v in NAME_TO_INTERNAL.items()}
